﻿using System;
using System.Windows.Input;

namespace Coding4Fun.MissionControl.WP.Models
{
    public class RelayCommand : ICommand
    {
        private Action<object> _executeAction;

        public RelayCommand(Action<object> executeAction)
        {
            this._executeAction = executeAction;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            _executeAction(parameter);
        }

        public event EventHandler CanExecuteChanged;
        public void RaiseCanExecuteChanged()
        {
            if (CanExecuteChanged != null)
                CanExecuteChanged(this, EventArgs.Empty);
        }
    }
}
