﻿using Coding4Fun.MissionControl.WP.Misc;
using System.Collections.Generic;

namespace Coding4Fun.MissionControl.WP.ViewModels
{
    public class SetsPageViewModel : BindableBase
    {
        static SetsPageViewModel instance = null;
        static readonly object padlock = new object();

        public SetsPageViewModel()
        {
            Sets = new List<Group<string>>();
        }

        public static SetsPageViewModel Instance
        {
            get
            {
                lock (padlock)
                {
                    if (instance == null)
                    {
                        instance = new SetsPageViewModel();
                    }
                    return instance;
                }
            }
        }

        private List<Group<string>> _sets;
        public List<Group<string>> Sets
        {
            get
            {
                return _sets;
            }
            set
            {
                SetProperty(ref _sets, value, "Sets");
            }
        }
    }
}
