﻿using System;
using Microsoft.Phone.Controls;
using Coding4Fun.MissionControl.WP.Misc;
using Coding4Fun.MissionControl.WP.ViewModels;

namespace Coding4Fun.MissionControl.WP.Views
{
    public partial class AddSetPage : PhoneApplicationPage
    {
        public AddSetPage()
        {
            InitializeComponent();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            NavigationService.GoBack();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            AttemptAddSet();
        }

        private async void AttemptAddSet()
        {
            if (!string.IsNullOrWhiteSpace(txtName.Text))
            {
                this.Focus();

                bool commandSent = await CommonViewModel.Instance.CommandClient.SendCommand(CommonViewModel.Instance.CurrentServer.Location, 
                    string.Format(Constants.COMMAND_CREATE_SET, ((ListPickerItem)lstType.SelectedItem).Content.ToString()), txtName.Text);
                if (!commandSent)
                {
                    Alert.Send(Constants.MESSAGE_SERVER_CONNECT_FAIL);
                }
                else
                {
                    CommonViewModel.Instance.IsWaiting = true;
                    NavigationService.GoBack();
                }
            }
            else
            {
                Alert.Send(Constants.MESSAGE_NO_NAME_FAIL);
            }
        }

        private void txtName_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == System.Windows.Input.Key.Enter)
                AttemptAddSet();
        }
    }
}